'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _postcss = require('postcss');

var _has = require('has');

var _has2 = _interopRequireDefault(_has);

var _browserslist = require('browserslist');

var _browserslist2 = _interopRequireDefault(_browserslist);

var _caniuseApi = require('caniuse-api');

var _fromInitial = require('../data/fromInitial.json');

var _fromInitial2 = _interopRequireDefault(_fromInitial);

var _toInitial = require('../data/toInitial.json');

var _toInitial2 = _interopRequireDefault(_toInitial);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initial = 'initial';

exports.default = (0, _postcss.plugin)('postcss-reduce-initial', function () {
    return function (css, result) {
        var resultOpts = result.opts || {};
        var browsers = (0, _browserslist2.default)(null, {
            stats: resultOpts.stats,
            path: __dirname,
            env: resultOpts.env
        });
        var initialSupport = (0, _caniuseApi.isSupported)('css-initial-value', browsers);
        css.walkDecls(function (decl) {
            var prop = decl.prop;

            if (initialSupport && (0, _has2.default)(_toInitial2.default, prop) && decl.value === _toInitial2.default[prop]) {
                decl.value = initial;
                return;
            }
            if (decl.value !== initial || !_fromInitial2.default[prop]) {
                return;
            }
            decl.value = _fromInitial2.default[prop];
        });
    };
});
module.exports = exports['default'];